(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('react'), require('react-final-form')) :
  typeof define === 'function' && define.amd ? define(['exports', 'react', 'react-final-form'], factory) :
  (factory((global['react-final-form-listeners'] = {}),global.React,global.ReactFinalForm));
}(this, (function (exports,React,reactFinalForm) { 'use strict';

  var classCallCheck = function (instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  };

  var createClass = function () {
    function defineProperties(target, props) {
      for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor) descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }

    return function (Constructor, protoProps, staticProps) {
      if (protoProps) defineProperties(Constructor.prototype, protoProps);
      if (staticProps) defineProperties(Constructor, staticProps);
      return Constructor;
    };
  }();

  var _extends = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };

  var inherits = function (subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
      throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
    }

    subClass.prototype = Object.create(superClass && superClass.prototype, {
      constructor: {
        value: subClass,
        enumerable: false,
        writable: true,
        configurable: true
      }
    });
    if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
  };

  var possibleConstructorReturn = function (self, call) {
    if (!self) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }

    return call && (typeof call === "object" || typeof call === "function") ? call : self;
  };

  //      

  var ExternallyChangedState = function (_React$Component) {
    inherits(ExternallyChangedState, _React$Component);

    function ExternallyChangedState(props) {
      classCallCheck(this, ExternallyChangedState);

      var _this = possibleConstructorReturn(this, (ExternallyChangedState.__proto__ || Object.getPrototypeOf(ExternallyChangedState)).call(this, props));

      _this.state = {
        previous: props.input.value,
        externallyChanged: false
      };
      return _this;
    }

    createClass(ExternallyChangedState, [{
      key: 'componentWillReceiveProps',
      value: function componentWillReceiveProps(nextProps) {
        var value = nextProps.input.value,
            active = nextProps.meta.active;
        var previous = this.state.previous;

        if (value !== previous) {
          this.setState({ previous: value, externallyChanged: !active });
        }
      }
    }, {
      key: 'render',
      value: function render() {
        return this.props.children(this.state.externallyChanged);
      }
    }]);
    return ExternallyChangedState;
  }(React.Component);

  var ExternallyChanged = function ExternallyChanged(_ref) {
    var name = _ref.name,
        children = _ref.children;
    return React.createElement(reactFinalForm.Field, {
      name: name,
      subscription: { active: true, value: true },
      allowNull: true,
      render: function render(props) {
        return React.createElement(ExternallyChangedState, _extends({}, props, { children: children }));
      }
    });
  };

  //      

  var OnBlurState = function (_React$Component) {
    inherits(OnBlurState, _React$Component);

    function OnBlurState(props) {
      classCallCheck(this, OnBlurState);

      var _this = possibleConstructorReturn(this, (OnBlurState.__proto__ || Object.getPrototypeOf(OnBlurState)).call(this, props));

      _this.state = {
        previous: !!props.meta.active
      };
      return _this;
    }

    createClass(OnBlurState, [{
      key: 'componentWillReceiveProps',
      value: function componentWillReceiveProps(nextProps) {
        var children = nextProps.children,
            active = nextProps.meta.active;
        var previous = this.state.previous;

        if (previous && !active) {
          children();
        }
        if (previous !== active) {
          this.setState({ previous: active });
        }
      }
    }, {
      key: 'render',
      value: function render() {
        return null;
      }
    }]);
    return OnBlurState;
  }(React.Component);

  var OnBlur = function OnBlur(_ref) {
    var name = _ref.name,
        children = _ref.children;
    return React.createElement(reactFinalForm.Field, {
      name: name,
      subscription: { active: true },
      render: function render(props) {
        return React.createElement(OnBlurState, _extends({}, props, { children: children }));
      }
    });
  };

  //      

  var OnChangeState = function (_React$Component) {
    inherits(OnChangeState, _React$Component);

    function OnChangeState(props) {
      classCallCheck(this, OnChangeState);

      var _this = possibleConstructorReturn(this, (OnChangeState.__proto__ || Object.getPrototypeOf(OnChangeState)).call(this, props));

      _this.state = {
        previous: props.input.value
      };
      return _this;
    }

    createClass(OnChangeState, [{
      key: 'componentWillReceiveProps',
      value: function componentWillReceiveProps(nextProps) {
        var children = nextProps.children,
            value = nextProps.input.value;
        var previous = this.state.previous;

        if (value !== previous) {
          this.setState({ previous: value });
          children(value, previous);
        }
      }
    }, {
      key: 'render',
      value: function render() {
        return null;
      }
    }]);
    return OnChangeState;
  }(React.Component);

  var OnChange = function OnChange(_ref) {
    var name = _ref.name,
        children = _ref.children;
    return React.createElement(reactFinalForm.Field, {
      name: name,
      subscription: { value: true },
      allowNull: true,
      render: function render(props) {
        return React.createElement(OnChangeState, _extends({}, props, { children: children }));
      }
    });
  };

  //      

  var OnFocusState = function (_React$Component) {
    inherits(OnFocusState, _React$Component);

    function OnFocusState(props) {
      classCallCheck(this, OnFocusState);

      var _this = possibleConstructorReturn(this, (OnFocusState.__proto__ || Object.getPrototypeOf(OnFocusState)).call(this, props));

      _this.state = {
        previous: !!props.meta.active
      };
      return _this;
    }

    createClass(OnFocusState, [{
      key: 'componentWillReceiveProps',
      value: function componentWillReceiveProps(nextProps) {
        var children = nextProps.children,
            active = nextProps.meta.active;
        var previous = this.state.previous;

        if (active && !previous) {
          this.setState({ previous: active });
          children();
        }
      }
    }, {
      key: 'render',
      value: function render() {
        return null;
      }
    }]);
    return OnFocusState;
  }(React.Component);

  var OnFocus = function OnFocus(_ref) {
    var name = _ref.name,
        children = _ref.children;
    return React.createElement(reactFinalForm.Field, {
      name: name,
      subscription: { active: true },
      render: function render(props) {
        return React.createElement(OnFocusState, _extends({}, props, { children: children }));
      }
    });
  };

  //

  exports.ExternallyChanged = ExternallyChanged;
  exports.OnBlur = OnBlur;
  exports.OnChange = OnChange;
  exports.OnFocus = OnFocus;

  Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=react-final-form-listeners.umd.js.map
